var slist = "";
for (i = 0; i < app.activeDocument.paragraphStyles.length; i++) {
	slist = slist + app.activeDocument.paragraphStyles[i].name + ",";
	}
for (i = 0; i < app.activeDocument.paragraphStyleGroups.length; i++) {
	tmpStr = app.activeDocument.paragraphStyleGroups[i].name
	for (j = 0; j < app.activeDocument.paragraphStyleGroups[i].paragraphStyles.length; j++) {
		slist = slist + tmpStr + " ∽∽ " + app.activeDocument.paragraphStyleGroups[i].paragraphStyles[j].name + ",";
		}
	}
slist = slist.replace ("[段落スタイルなし],[基本段落],", "");
slist = slist.substring (0, slist.length-1);
slist = slist.split (",");

var olist = "";
for(i=0; i<app.activeDocument.objectStyles.length; i++) {
	olist = olist + app.activeDocument.objectStyles[i].name + ",";
	}
olist = olist.replace ("[None],[Normal Graphics Frame],[Normal Text Frame],[Normal Grid],", "");
olist = olist.substring (0, olist.length-1);
olist = olist.split (",");

dlg = app.dialogs.add({name:"画像配置スクリプト"});
dlc = dlg.dialogColumns.add();
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:"【検索条件】"});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:"条件に当てはまる文字列を ★ とし、【配置ファイル名】で使用"});
	}
with(dlc.dialogRows.add()){ 
	myStr1 = textEditboxes.add({editContents:".+", minWidth:260});
	}
with(dlc.dialogRows.add()){ 
	myPStyle = dropdowns.add({stringList: slist, selectedIndex:0, minWidth:260});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:" "});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:"【配置ファイル名】"});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:"前につける文字         後ろにつける文字       拡張子"});
	}
with(dlc.dialogRows.add()){ 
	myName1 = textEditboxes.add({editContents:"", minWidth:80});
	staticTexts.add({staticLabel:"★ "});
	myName2 = textEditboxes.add({editContents:"", minWidth:80});
	staticTexts.add({staticLabel:". "});
	myName3 = textEditboxes.add({editContents:"eps", minWidth:40});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:" "});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:"【貼りこみサイズ】"});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:"幅"});
	sizeX = realEditboxes.add({editValue:50, minimumValue:10, maximumValue:100, minWidth:60});
	staticTexts.add({staticLabel:"× 高さ"});
	sizeY = realEditboxes.add({editValue:45, minimumValue:10, maximumValue:100, minWidth:60});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:" "});
	}
with(dlc.dialogRows.add()){
	staticTexts.add({staticLabel:"【適用オブジェクトスタイル】"});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:"アンカー付オブジェクトが設定されているスタイルを推奨"});
	}
with(dlc.dialogRows.add()){
	myOStyle = dropdowns.add({stringList: olist, selectedIndex:0, minWidth:260});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:" "});
	}
with(dlc.dialogRows.add()){
	staticTexts.add({staticLabel:"【フィット設定】"});
	}
with(dlc.radiobuttonGroups.add()){ 
	myRadio1 = radiobuttonControls.add({staticLabel: "内容をフレーム内に収める", checkedState:true});
	myRadio2 = radiobuttonControls.add({staticLabel: "フレームに均等に流し込む"});
	myRadio3 = radiobuttonControls.add({staticLabel: "フィットなし"});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:" "});
	}
with(dlc.dialogRows.add()){
	staticTexts.add({staticLabel:"【その他設定】"});
	}
with(dlc.dialogRows.add()){
	myCheck1 = checkboxControls.add({staticLabel: "フレームのセンター", checkedState:true});
	myCheck2 = checkboxControls.add({staticLabel: "使用画像を『使用済』フォルダへ移動", checkedState:true});
	}
flag = dlg.show();

if (flag == true) {
	if (slist == "" || olist == "") {
		alert("段落スタイル／オブジェクトスタイルが設定されていません。");
		flag = false;
		} else {
			if ((app.activeDocument.objectStyles.item(myOStyle.stringList[myOStyle.selectedIndex]).enableAnchoredObjectOptions == false) || (app.activeDocument.objectStyles.item(myOStyle.stringList[myOStyle.selectedIndex]).anchoredObjectSettings.anchoredPosition != 1097814113)) {
				dlg = app.dialogs.add({name:"警告メッセージ"});
				dlc = dlg.dialogColumns.add();
				with(dlc.dialogRows.add()){ 
					staticTexts.add({staticLabel:"選択オブジェクトスタイルにはアンカー付オブジェクトが設定されていません！"});
					}
				with(dlc.dialogRows.add()){ 
					staticTexts.add({staticLabel:"※このスクリプトはアンカー付オブジェクト設定推奨です。"});
					}
				with(dlc.dialogRows.add()){ 
					staticTexts.add({staticLabel:"   不具合が生じる可能性が高くなりますが、継続しますか？"});
					}
				flag = dlg.show();
				}
			}
	}

if (flag == true) {
	app.findGrepPreferences = NothingEnum.nothing;
	app.changeGrepPreferences = NothingEnum.nothing;
	app.findGrepPreferences.findWhat = myStr1.editContents;
	tmpPStyle = myPStyle.stringList[myPStyle.selectedIndex];
	if (tmpPStyle.match (" ∽∽ ")) {
		PStyle = tmpPStyle.split(" ∽∽ ");
		app.findGrepPreferences.appliedParagraphStyle = app.activeDocument.paragraphStyleGroups.itemByName(PStyle[0]).paragraphStyles.itemByName(PStyle[1]);
		} else {app.findGrepPreferences.appliedParagraphStyle = tmpPStyle;}
	
	foldername = Folder.selectDialog("配置ファイルがあるフォルダを選択");
	if (foldername) {
		myDoc = app.activeDocument;
		if (myCheck2.checkedState == true) {
			folderObj = new Folder(foldername + "/使用済");
			folderObj.create();
			}

		fnText = myDoc.findGrep();//検索対象がどれだけあるか判定用
		
		var pbarWidth = 230;	// プログレスバーの幅
		var max = fnText.length;	// 最大値
		var pbarPanel = createProgressBarPanel(max, pbarWidth);
		pbarPanel.show();	// プログレスバーを表示
		
		for (i = 0; i < fnText.length; i++) {
			pbarPanel.progressBar.value = i;
			fnText = myDoc.findGrep();//これがないと同じテキストフレーム内に2つあったときにズレる。。。
			tmpConst = fnText[i];
			while(tmpConst.parent.constructor.name != "Page") {
				if (tmpConst.parent.constructor.name == "Spread") {break;}
				switch(tmpConst.constructor.name) {
					case "Paragraph":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
					case "TextStyleRange":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
					case "Character":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
					case "Word":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
					case "InsertionPoint":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
					case "TextColumn":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
					case "Line":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
					case "Text":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
					default: tmpConst = tmpConst.parent;
					}
				}
			if (tmpConst.constructor.name == "Group") {
				selObj = tmpSel;
				} else {selObj = tmpConst;}
			Str1 = myName1.editContents;
			Str2 = myName2.editContents;
			Str3 = myName3.editContents;
			if ((Str1.match(/\*/) == "*") || (Str2.match(/\*/) == "*") || (Str3.match(/\*/) == "*")) {
				var tmpGF = Str1+ fnText[i].contents + Str2 + "." + myName3.editContents;
				var getName = foldername.getFiles(tmpGF);
				if (getName.length > 0) {
					var myFile = getName[0];
					var tmpStr = getName[0] + "";
					var tmpStr = tmpStr.replace (foldername + "/", "");
					haichi(myFile,tmpStr);
					}
				}
			var tmpStr = Str1 + fnText[i].contents + Str2 + "." + Str3;
			myFile = new File(foldername+ "/" + tmpStr);
			haichi(myFile,tmpStr);
			}
		}
	}

function haichi() {
	if (myFile.exists) {
		try {
			obj = selObj.lines[0].textFrames.add();
			obj.applyObjectStyle(app.activeDocument.objectStyles.item(myOStyle.stringList[myOStyle.selectedIndex]));
			obj.visibleBounds = [0, 0, sizeY.editValue, sizeX.editValue];
			if (myCheck2.checkedState == true) {
				myFile.copy(folderObj+ "/" + tmpStr);
				myFile.remove();
				myFile = new File(folderObj+ "/" + tmpStr);
				}
			obj.place(myFile);
			if (myRadio1.checkedState == true) {
				obj.fit(FitOptions.proportionally);
				}
			if (myRadio2.checkedState == true) {
				obj.fit(FitOptions.fillProportionally);
				}
			if (myCheck1.checkedState == true) {
				obj.fit(FitOptions.centerContent);
				}
			} catch(obj) {}
		}
	}

////////////////////////////////////////////プログレスバー
function createProgressBarPanel(maxValue, pBarWidth){
	var pBar = new Window("window", "処理中...");
	pBar.progressBar = pBar.add("progressbar", [12, 12, pBarWidth, 32], 0, maxValue);
	return pBar;
}